<template>
  <section class="container">
      <div class="row">
        <div class="col-md-12">
          <div id="chat-content">
            <p v-for="data in chats">
              <span>{{ data.name }} :</span>
              <template v-if="data.type == 1">
                <div>
                  <img :src="data.message" alt="">
                </div>
              </template>
              <template v-else>
                <div>
                  <strong>{{ data.message }}</strong>
                </div>
              </template>
            </p>
          </div>
          <br>
           <b-form-group
            id="input-group-1"
            label="Email address:"
            label-for="input-1"
            description="We'll never share your email with anyone else."
          >
            <b-form-input
              id="input-1"
              v-model="loggedInUser.name"
              type="text"
              required
              placeholder="Name"
            ></b-form-input>
          </b-form-group>

          <b-form-textarea
            id="textarea"
            v-model="text"
            placeholder="Enter something..."
            rows="3"
            max-rows="6"
          ></b-form-textarea>
          
           <b-button @click="sendMessage()" variant="outline-primary">Send</b-button>
           <b-form-file
            v-model="image"
            :state="Boolean(image)"
            placeholder="Choose a file..."
            drop-placeholder="Drop file here..."
          ></b-form-file>
           <b-button @click="sendImage()" variant="outline-primary">Send</b-button>

        </div>
      </div>
  </section>
</template>

<script>
import io from 'socket.io-client';
import {mapGetters} from 'vuex';
export default {
  components: {
  },
  data() {
    return {
      title: 'Ví dụ về websocket',
      image:{},
      text: '',
      name: '',
      socket: {},
      chats: []
    }
  },
  computed: {
    ...mapGetters(['isAuthenticated', 'loggedInUser'])
  },
  methods: {
    sendMessage() {
      let data = {
        name: this.name,
        message: this.text
      };
      this.socket.emit('new_message', data);
      this.chats.push(data);
    },
    async sendImage() {
      var formData = new FormData();
      formData.append("image", this.image);
      let {data} = await this.$axios.post('/api/upload', formData, {
          headers: {
            'Content-Type': 'multipart/form-data'
          }
      });
      let data2 = {
        name: this.name,
        message: data.data.filename,
        type: 1
      }
      console.log(data);

      this.socket.emit('new_message', data2);
      this.chats.push(data2);
    },
    async getMessages() {
      let {data} = await this.$axios.get('/api/messages');
      this.chats = data.data;
    }
  },
  created(){
    this.getMessages();
  },
  mounted(){
    setTimeout(()=>{
      this.title = "(1)" + this.title;
    }, 2000)
    this.socket = io('http://localhost:3000');
    this.socket.on('connect', () => {
      this.socket.emit('authentication',{
        token : 'asdasdsa.asdasdsa.1asdsadsa'
      })
      console.log('connected');
      this.socket.on('new_message', (data) => {
        this.chats.push(data);
      })
    })
  },
  head () {
    return {
      title: this.title,
      meta: [
        // hid is used as unique identifier. Do not use `vmid` for it as it will not work
        { hid: 'description', name: 'description', content: 'My custom description' }
      ]
    }
  }

}
</script>

<style>
#chat-content{
  min-height: 300px;
  border:solid 1px;
  border-radius: 4px;
}
</style>
